package de.devloop.mavor;

import java.io.IOException;

import jakarta.servlet.ServletException;
import jakarta.servlet.http.HttpServlet;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;

public class AuthenticatedServlet extends HttpServlet {
    protected Session session;

    @Override
    protected final void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        session = new Session(req.getSession(true));
        if (!session.isAuthenticated()) {
            resp.sendRedirect("/mavor/authenticate");
        } else {
            doAuthenticatedGet(req, resp);
        }
    }

    @Override
    protected final void doPost(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        session = new Session(req.getSession(true));
        if (!session.isAuthenticated()) {
            resp.sendRedirect("/mavor/authenticate");
        } else {
            doAuthenticatedPost(req, resp);
        }
    }

    protected void doAuthenticatedGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        // nooooothing
    }

    protected void doAuthenticatedPost(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        // nooooothing
    }
}